#include<iostream>
#include<cstdio>
#include<cmath>
#include<ctime>
#include<algorithm>
#include<vector> 
#include<cstring>
#include<string>
#include<map>
#define mp make_pair
#define scn second
#define frs first
#define pb push_back

#define NAME "graph"

using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<ll, int> pi;
const int P = 239017;

int used[1000000], tin[1000000], tup[1000000], bridge[1000000];
vector<pi> g[1000000];
int n, m, timer;
int b_cnt = 0;
vector<int> new_g[1000000];


void dfs1(int v, int p) {
    used[v] = 1;
    tin[v] = tup[v] = timer++;
    for (int i = 0; i < g[v].size(); ++i) {
    	int to = g[v][i].frs;
    	if (p == to)
    		continue;
    	if (!used[to]) {
    		dfs1(to, v);
    		tup[v] = min(tup[to], tup[v]);
    		if (tup[to] > tin[v]) {
				bridge[g[v][i].scn] = 1, ++b_cnt;
				new_g[v].pb(g[v][i].frs);
				new_g[g[v][i].frs].pb(v);
			}
    	} else {
    	  	tup[v] = min(tup[v], tin[to]);
    	}	    	    	
    }	
}
int dfs2(int v) {
    int ans = 1;
    used[v] = 1;
    for (int i = 0; i < new_g[v].size(); ++i) {
    	if (used[new_g[v][i]])
    		continue;
    	ans += dfs2(new_g[v][i]);
    }
    return ans;	
}



int main(){
    freopen(NAME ".in", "r", stdin); 
    freopen(NAME ".out", "w", stdout); 
    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; ++i) {
    	int a, b;
    	scanf("%d%d", &a, &b);
    	g[a].pb(mp(b, i));
    	g[b].pb(mp(a, i));
    }
    
    for (int i = 1; i <= n; ++i) {
   		if (!used[i])
   			dfs1(i, -1); 	
    }
    for (int i = 1; i <= n; ++i)
    	used[i] = 0;
    vector<int> arr;
    for (int i = 1; i <= n; ++i)
    	if (!used[i])
    		arr.pb(dfs2(i));
    ll ans = 0;
    
    /*for (int i = 0; i < arr.size(); ++i)
    	ans += arr[i];
    ans *= ans;*/
    cerr << arr[0];
    for (int i = 0; i < arr.size(); ++i)
    	ans += 1LL * (arr[i] - 1) * (arr[i] - 2) / 2;
    //ans/=2;    
    //ans = arr.size() * (arr.size() - 1) / 2;
    printf("%I64d", ans);    
    return 0;
}




