/**
 * Created by GShark on 19.09.2014.
 */
import java.util.ArrayList;
import java.util.Arrays;

import java.util.List;

import ru.ifmo.testlib.*;
import ru.ifmo.testlib.Outcome.Type;

public class Check implements Checker {

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt(), m = inf.nextInt();
        boolean[] was = new boolean[m];
        inf.nextLine();
        String str = inf.nextToken();
        String[] arr = new String[m];
        for (int i = 0; i < m; i++) {
        	arr[i] = inf.nextToken();
        	was[i] = false;
        	inf.nextLine();
        }
        ArrayList<Integer> pAns = new ArrayList<Integer>();
        for (int i = 0; i < m; ++i) {
        	pAns.add(ouf.nextInt());
        	try {
				if (was[pAns.get(pAns.size() - 1) - 1])
        			return new Outcome(Type.WA, "WA");
				was[pAns.get(pAns.size() - 1) - 1] = true;
			} catch (Exception e) {
				return new Outcome(Type.WA, "PE");
				
			}				        	
        }
		int y = 0;
		for (int i = 0; i < pAns.size(); i++) {
			String now = null;
		    try {
				now = arr[pAns.get(i) - 1];
			} catch (Exception e) {
				return new Outcome(Type.WA, "PE");
			}
			for (int j = 0; j < now.length(); j++)
				if (now.charAt(j) != str.charAt(y++)) {
					return new Outcome(Type.WA, "WA");
				}
		}	         
        if (!ouf.seekEoF()) {
            return new Outcome(Type.WA, "to much tokens in answer");
        }
        return new Outcome(Type.OK, "OK");
    }
}
