#include<iostream>
#include<cstdio>
#include<cmath>
#include<ctime>
#include<algorithm>
#include<vector> 
#include<cstring>
#include<string>
#include<map>
#define mp make_pair
#define scn second
#define frs first
#define pb push_back

#define NAME "tree"

using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<ll, int> pi;
const int P = 239017;

int MIN = 1;
int func(int a, int b) {
	if (MIN)
		return a <= b;
	return a >= b;
}
vector<pi> t[100000];	
int killed[100000], sz[100000], a[100000], f[1000000];
vector<int> g[100000];
int n;


int build_size(int v, int p) {
    sz[v] = 1;
    for (int i = 0; i < g[v].size(); ++i) {
    	if (g[v][i] == p || killed[g[v][i]])
    		continue;
    	sz[v] += build_size(g[v][i], v);
    }
    return sz[v];
}
int find_start(int v, int p, int size) {
    for (int i = 0; i < g[v].size(); ++i) {
    	if (g[v][i] == p || killed[g[v][i]])
    		continue;
    	if (sz[g[v][i]] > size / 2)
    		return find_start(g[v][i], v, size);
    }
	return v;
}

/*pi take_from_killed(int v, int dir) {	
    pi sum = mp(0, 0);
	for (int j = 0; j < g[v].size(); ++j) {
		if (g[v][j] == dir)
			continue;
		sum.frs += t[v][j].frs;
		sum.scn += t[v][j].scn;
	}
	sum.frs += sum.scn;
	sum.frs += 2;
	sum.scn += 1;
	return sum;
}*/

pi find_path(int v, int p, int d, int val) {
	if (func(f[v], val))
		return mp(0, 0);
	pi ans = mp(d, 1);
	for (int i = 0; i < g[v].size(); ++i) {
		if (g[v][i] == p)
			continue;          
		/*if (killed[g[v][i]]) {
			int to = g[v][i];
			if (!func(f[to], val)) { 
				pi sum = take_from_killed(to, v);
				ans.frs += sum.frs;
				ans.scn += sum.scn;
			}
			continue;
		}*/
		pi tmp = find_path(g[v][i], v, d + 1, val);
		ans.frs += tmp.frs;
		ans.scn += tmp.scn;

	}
	return ans;
}

ll iterate(int v) {
	for (int i = 0; i < g[v].size(); ++i) {
		/*if (killed[g[v][i]]) {
			if (!func(f[g[v][i]], f[v])) {
				t[v].pb(take_from_killed(g[v][i], v));
			}
			else
				t[v].pb(mp(0, 0));
			continue;
		}*/			
		t[v].pb(find_path(g[v][i], v, 2, f[v]));
	}	
	ll ans = 0;
	for (int i = 0; i < t[v].size(); ++i) {
		ans += t[v][i].frs;
		for (int j = i + 1; j < t[v].size(); ++j)
			ans += (ll)t[v][i].frs * t[v][j].scn + (ll)t[v][i].scn * (t[v][j].frs - t[v][j].scn);
	}
	return ans;
}

ll dfs(int v) {
	ll ans = 0;	
	int sz = build_size(v, -1);
	v = find_start(v, -1, sz);	
	ans += iterate(v) * a[v];
	killed[v] = 1;
	for (int i = 0; i < g[v].size(); ++i) {
		if (!killed[g[v][i]])
			ans += dfs(g[v][i]);
	}
	return ans;
}



int main(){
    freopen(NAME ".in", "r", stdin); 
    freopen(NAME ".out", "w", stdout); 
    scanf("%d", &n);
    vector<pi> arr;
    for (int i = 1; i <= n; ++i) {
    	scanf("%d", &a[i]);
    	arr.pb(mp(a[i], i));    	    	    		
    }
    sort(arr.begin(), arr.end());
    for (int i = 0; i < arr.size(); ++i) {    	
    	f[arr[i].scn] = i;
    }
    for (int i = 0; i < n - 1; ++i) {
    	int a, b;
    	scanf("%d%d", &a, &b);
    	g[a].pb(b);
    	g[b].pb(a);
    }
    ll mn = dfs(1);
    for (int i = 1; i <= n; ++i)
    	killed[i] = 0, t[i].clear();
    MIN = 0;
    ll mx = dfs(1);
    //for (int i = 0; i < t[1].size(); ++i)
    //	cerr << t[1][i].frs << " " << t[1][i].scn << "\n";
    //cerr << mn << " " << mx;
    printf("%I64d", mx - mn);    
    return 0;
}




