#include<iostream>
#include<cstdio>
#include<cassert>
#include<cmath>
#include<ctime>
#include<algorithm>
#include<vector> 
#include<cstring>
#include<string>
#include<map>
#include<set>

#define mp make_pair
#define scn second
#define frs first
#define pb push_back

#define NAME "diagram"

using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<ll, int> pi;
const int P = 239017;
const ll INF = 1000000000000000000ll;

ll f[2000][2000];
ll dp[2000][200];
int was[2000][200];
ll go(int n, int k) {
	if (n == 0)
		return 0;	
	if (k == 0)
		return INF;			
	if (was[n][k])
		return dp[n][k];
	was[n][k] = 1;
	ll ans = INF;
	for (int i = 1; i <= n; i++) {
		ans = min(ans, go(n - i, k - 1) + f[n - i][n - 1]);
	}
	return dp[n][k] = ans;
}

int n, k, a[2000];

int main(){
    freopen(NAME ".in", "r", stdin); 
    freopen(NAME ".out", "w", stdout); 
    scanf("%d%d", &n, &k);
    k++;
    for (int i = 0; i < n; ++i)
    	scanf("%d", &a[i]);
    
    for (int i = 0; i < n; ++i) {
     	multiset<int> s1, s2;
		ll sum1 = 0, sum2 = 0;
     	f[i][i] = 0;
     	if (i == n - 1)
     		break;
     	f[i][i + 1] = abs(a[i] - a[i + 1]);
     	s1.insert(min(a[i], a[i+1]));
		s2.insert(max(a[i], a[i+1]));
		sum1 = *s1.begin();
		sum2 = *s2.begin();
     	for (int j = i + 2; j < n; ++j) {
     		int now = a[j];
     		if (*s1.rbegin() > now)
     			s1.insert(now), sum1 += now;
     		else
     			s2.insert(now), sum2 += now;
     		if ((int)s1.size() - 1 - (int)s2.size() > 1) {
     			int tran = *s1.rbegin();
     			sum1 -= tran;
     			sum2 += tran;
     			multiset<int>::iterator it = s1.end();
     			--it;
     			s1.erase(it);
     			s2.insert(tran);
     		}
			if ((int)s2.size() - (int)s1.size() + 1 > 1) {
     			int tran = *s2.begin();
     			sum2 -= tran;
     			sum1 += tran;
     			multiset<int>::iterator it = s2.begin();
     			it++;
     			s2.erase(s2.begin());
     			s1.insert(tran);
     		}
     		ll m = *s1.rbegin();
     		f[i][j] = m * s1.size() - sum1 + sum2 - (ll)m * s2.size();      		
     	}    	
    }
    /*
    for (int i = 0; i < n; ++i) {
    	for (int j = i; j < n; ++j) {
    		cerr << "f[" << i << "][" << j << "] = " << f[i][j] << "\n";
    	}
    }
    */
    /*
    for (int i = 0; i < n; ++i) {
    	for (int j = i; j < n; ++j) {
    		vector<int> v;
    		ll sum = 0;
    		for (int k = i; k <= j; ++k)	
    			v.pb(a[k]), sum += a[k];
    		sort(v.begin(), v.end());
    		ll ans = INF, s = 0;
    		for (int k = 0; k < v.size(); ++k) {
    			s += v[k];
    			ans = min(ans, ((ll)(k + 1) * v[k] - s) + (sum - s) - ((ll)v.size() - k - 1) * v[k]);
    		}
    		//cerr << ans << " " << f[i][j] << "\n";
    		if (ans != f[i][j]) 
    			cerr << ans << " " << f[i][j] << "\n";    	
    		assert(ans == f[i][j]);    		
    		//f[i][j] = ans;
    	}
    }
    */
    printf("%I64d", go(n, k));       
    return 0;
}




