#include <bits/stdc++.h>

using namespace std;

const int maxD = 1400;

vector < vector <int> > divisors(2);
vector <int> ds[2][maxD];

void precalc(int id, int x) {
    for (int i = 1; i * i <= x; i++)
        if (x % i == 0) {
            divisors[id].push_back(i);
            if (i * i != x)
                divisors[id].push_back(x / i);
        }
    sort(divisors[id].begin(), divisors[id].end());

    for (size_t i = 0; i < divisors[id].size(); i++) {
        int x = divisors[id][i];
        for (size_t idx = 1; idx < divisors[id].size() && divisors[id][idx] <= x; idx++)
            if (x % divisors[id][idx] == 0)
                ds[id][i].push_back(idx);
    }
}

bool was[maxD][maxD];
bool dp[maxD][maxD];

bool go(int aPos, int bPos) {
    if (aPos == 0 || bPos == 0) {
        return (aPos == 0 && bPos == 0) ? false : true;
    }
    if (was[aPos][bPos])
        return dp[aPos][bPos];
    was[aPos][bPos] = true;
    for (size_t i = 0; i < ds[0][aPos].size(); i++) {
        int d = ds[0][aPos][i];
        int newnum = divisors[0][aPos] / divisors[0][d];
        d = divisors[0][d];
        int pos = lower_bound(divisors[0].begin(), divisors[0].end(), newnum) - divisors[0].begin();
        if (!go(pos, bPos))
            return dp[aPos][bPos] = true;
        if (divisors[1][bPos] % d == 0) {
            int pos2 = lower_bound(divisors[1].begin(), divisors[1].end(), divisors[1][bPos] / d) - divisors[1].begin();
            if (!go(pos, pos2))
                return dp[aPos][bPos] = true;
        }
    }

    for (size_t i = 0; i < ds[1][bPos].size(); i++) {
        int d = ds[1][bPos][i];
        int newnum = divisors[1][bPos] / divisors[1][d];
        d = divisors[1][d];
        int pos = lower_bound(divisors[1].begin(), divisors[1].end(), newnum) - divisors[1].begin();
        if (!go(aPos, pos))
            return dp[aPos][bPos] = true;
    } 
    return dp[aPos][bPos] = false;
}

int main() {
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    int a, b;
    scanf("%d%d", &a, &b);
    if (a == 1 || b == 1) {
        printf("%s\n", (a == 1 && b == 1) ? "Alf wins" : "Lucky wins");
        return 0;
    }

    precalc(0, a);
    precalc(1, b);
    if (!go(divisors[0].size() - 1, divisors[1].size() - 1))
        printf("Alf wins\n");
    else
        printf("Lucky wins\n");
    return 0;
}